Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 19250)
+++ channels/chan_sip.c	(working copy)
@@ -16652,10 +16652,21 @@
 	} else if (!ast_strlen_zero(c = get_header(req, "X-ClientCode"))) {
 		/* Client code (from SNOM phone) */
 		if (ast_test_flag(&p->flags[0], SIP_USECLIENTCODE)) {
-			if (p->owner && p->owner->cdr)
-				ast_cdr_setuserfield(p->owner, c);
-			if (p->owner && ast_bridged_channel(p->owner) && ast_bridged_channel(p->owner)->cdr)
-				ast_cdr_setuserfield(ast_bridged_channel(p->owner), c);
+			struct ast_channel *chan = p->owner;
+
+			if (chan) {
+				pbx_builtin_setvar_helper(chan, "SIPCLIENTCODE", c);
+				manager_event(EVENT_FLAG_SYSTEM, "ChannelUpdate",
+					"Channel: %s\r\nChanneltype: %s\r\nUniqueid: %s\r\nX-ClientCode: %s\r\n",
+					chan->name, "SIP", chan->uniqueid, c);
+				if (chan->cdr) {
+					ast_cdr_setuserfield(chan, c);
+				}
+				chan = ast_bridged_channel(p->owner);
+				if (chan && chan->cdr) {
+					ast_cdr_setuserfield(chan, c);
+				}
+			}
 			transmit_response(p, "200 OK", req);
 		} else {
 			transmit_response(p, "403 Forbidden", req);
